//  Adott egy n egsz szmbl ll szmsorozat, amely biztosan tartalmaz legalbb egy pozitv 
// szmot. Hatrozzuk meg azt a leghosszabb tmbszakaszt, amelynek sszege a lehet legnagyobb.

#include <iostream>
#include <fstream>

using namespace std;

int const maxDim = 100;

void beOlvas(int & n, int t[]){
//sorozat beolvasasa

	ifstream fin ("be2.in");
	fin >> n;
	for(int i = 1; i <= n; i++)
		fin >> t[i];
}

void kiir(int eleje, int vege, int t[]){
// kirs

	cout << "Hossz = " << vege - eleje + 1 << endl;
	for(int i = eleje; i <= vege; i++)
		cout << t[i] << " ";
	cout << endl;
}

void maxOsszeg_1(int n , int t[], int & maxOsszeg, int & eleje, int & vege){
// meghatrozzuk azt a leghosszabb tmbszakaszt, amelynek sszege a lehet legnagyobb.
// O(n^3)

	int osszeg;
	maxOsszeg = t[1]; 
	for(int bal = 1; bal <= n; bal++){
		for(int jobb = bal; jobb <= n; jobb++){
			osszeg = 0;
			for(int k = bal; k <= jobb; k++)
				osszeg = osszeg + t[k];	
			if(maxOsszeg < osszeg){
				maxOsszeg = osszeg;
				eleje = bal;
				vege = jobb;
			}
			else
				if((maxOsszeg == osszeg) && (vege - eleje < jobb - bal)){
					maxOsszeg = osszeg;
					eleje = bal;
					vege = jobb;
				}
		}
	}
}

void maxOsszeg_2(int n , int t[], int & maxOsszeg, int & eleje, int & vege){
// meghatrozzuk azt a leghosszabb tmbszakaszt, amelynek sszege a lehet legnagyobb.
// O(n^2)

	maxOsszeg = t[1]; 
	for(int bal = 1; bal <= n; bal++){
		int osszeg = 0;
		for(int jobb = bal; jobb <= n; jobb++){
			osszeg = osszeg + t[jobb];	
			if(maxOsszeg < osszeg){
				maxOsszeg = osszeg;
				eleje = bal;
				vege = jobb;
			}
			else
				if((maxOsszeg == osszeg) && (vege - eleje < jobb - bal)){
					maxOsszeg = osszeg;
					eleje = bal;
					vege = jobb;
				}
		}
	}
}

void maxOsszeg_3(int n, int t[], int & maxOsszeg, int & eleje, int & vege){
// meghatrozzuk azt a leghosszabb tmbszakaszt, amelynek sszege a lehet legnagyobb.
// O(n^2)

	int reszOsszeg[100];
	reszOsszeg[1] = 0;
	for(int i = 1; i <= n; i++)
		reszOsszeg[i] = reszOsszeg[i-1] + t[i];
	maxOsszeg = t[1];
	eleje = 1;
	vege = 1;
	
	for(int bal = 1; bal <= n; bal++){
		for(int jobb = bal; jobb <= n; jobb++){
			int osszeg = reszOsszeg[jobb] - reszOsszeg[bal - 1];		
			if(maxOsszeg < osszeg){
				maxOsszeg = osszeg;
				eleje = bal;
				vege = jobb;
			}
			else
				if((maxOsszeg == osszeg) && (vege - eleje < jobb - bal)){
					maxOsszeg = osszeg;
					eleje = bal;
					vege = jobb;
				}
		}
	}
}

void maxOsszeg_4(int n , int t[], int & maxOsszeg, int & eleje, int & vege){	
// meghatrozzuk azt a leghosszabb tmbszakaszt, amelynek sszege a lehet legnagyobb
// O(n)
	
	maxOsszeg = t[1];
	int osszeg = maxOsszeg;
	eleje = 1;
	vege = 1;
	int kezd = 1;
	
	for(int i = 2; i <= n; i++){
		if(osszeg < 0){
			osszeg = t[i];
			kezd = i;
		}
		else
			osszeg = osszeg + t[i];	
		if(maxOsszeg < osszeg){
			maxOsszeg = osszeg;
			eleje = kezd;
			vege = i;
		}
		else
			if((maxOsszeg == osszeg) && (vege - eleje < i - kezd)){
				eleje = kezd;
				vege = i;
			}
	}
}

int main(){
	
	int t[maxDim]; 
	int n;
	int maxOsszeg;
	int eleje, vege;
	
	beOlvas(n, t);
	kiir(1, n, t);	// az adott sorozat
    
    cout << "Max Osszegu leghosszabb tombszakasz (1. megoldas): " << endl;    
	maxOsszeg_1(n, t, maxOsszeg, eleje, vege);
	kiir(eleje, vege, t);
	cout << "Legnagyobb osszeg = " << maxOsszeg << endl << endl;
	
	cout << "Max Osszegu leghosszabb tombszakasz (2. megoldas): " << endl;    
	maxOsszeg_2(n, t, maxOsszeg, eleje, vege);
	kiir(eleje, vege, t);
	cout << "Legnagyobb osszeg = " << maxOsszeg << endl << endl;
	
	cout << "Max Osszegu leghosszabb tombszakasz (3. megoldas): " << endl;    
	maxOsszeg_3(n, t, maxOsszeg, eleje, vege);
	kiir(eleje, vege, t);
	cout << "Legnagyobb osszeg = " << maxOsszeg << endl << endl;
	
	cout << "Max Osszegu leghosszabb tombszakasz (4. megoldas): " << endl;    
	maxOsszeg_4(n, t, maxOsszeg, eleje, vege);
	kiir(eleje, vege, t);
	cout << "Legnagyobb osszeg = " << maxOsszeg << endl << endl;
}
  
