/* 
Egy természetes számokat tartalmazó sorozatot palindromnak nevezünk, ha balról jobbra olvasva, ugyanazt a sorozatot 
kapjuk, mintha jobbról balra haladva olvasnánk. Például az (1, 2, 3, 2, 1) sorozat palindrom, míg az (1, 2, 3, 2, 4) 
nem palindrom. 
Egy természetes számokat tartalmazó sorozat ciklikus palindrom, ha az elemeinek néhány körkörös permutációjával 
palindrommá alakítható. Az elemek körkörös permutációja alatt a sorozat elemeinek egy pozíci¬óval balra tolását 
értjük (kivételt képez az első elem, amely a sorozat utolsó pozíciójára k¬rül). 
Írjatok programot, amely eldönti, hogy az n elemű (1 ≤ n ≤ 1 000), természetes számokat tartalmazó a sorozat 
ciklikus palindrom-e vagy sem, és kiír egy megfelelő üzenetet (Igen/Nem). Ha a döntés eredménye Igen, a program 
meghatározza azoknak a körkörös permutációknak a számát, amelyekkel a sorozat palindrommá alakítható. 
1. Példa: az a = (1, 1, 2, 2) sorozat az (1, 2, 2, 1) egyetlen körkörös permutációval palindrommá alakítható.
2. Példa: az a = (3, 4, 3, 2, 1, 1, 2) sorozat öt körkörös permutációval palindrommá alakítható: 
(4, 3, 2, 1, 1, 2, 3); (3, 2, 1, 1, 2, 3, 4); (2, 1, 1, 2, 3, 4, 3); (1, 1, 2, 3, 4, 3, 2); (1, 2, 3, 4, 3, 2, 1). 
3. Példa: az a = (1, 2, 3) sorozat nem alakítható palindrommá körkörös permutációkkal.
*/

#include <iostream>
#include <fstream>

using namespace std; 

const int maxDim = 1000;

void beOlvas(int & n, int a[]){
// bemenet   

	ifstream f("pal5.in");
  	f >> n; 
  	for(int i = 0; i < n; i++)
  		f >> a[i];
}

void kiIr(int n, int a[]){
// kiírjuk

	for(int i = 0; i < n; i++)
    	cout << a[i] << " ";
  	cout << endl;
}

bool palindrom_e(int n, int a[], int eleje, int vege){
// eldöntjük, hogy eleje és vege között palindrom tulajdonságú-e a sorozat

	int i = eleje;
	int j = vege;
	while ((a[i] == a[j]) && (i < j)){
		i++;
		j--;
	}
	return i >= j;
}

int ciklikusPalindrom(int n, int a[]){
// eldöntjük, hogy körkörös palindrom-e a sorozatunk

	for (int i = 0; i < n; i++)	// megkétszerezzük a sorozatot
		a[n + i] = a[i];

	bool megvan = false;
	int i = 0;
	while ((i < n) && !megvan){
		megvan = palindrom_e(n, a, i, i + n - 1);
		i++;
	}
	if (megvan)
		return i - 1;
	else
		return -1;
}

void kiirEredmeny(int permSz){
	
	if (permSz == -1)
		cout << "Nem" << endl;
	else
		if(permSz == 0)
			cout << "Az adott sorozat palindrom tulajdonsagu" << endl;
		else
			cout << "Igen, permutaciok szama: " << permSz << endl;
}

int main(){

int n;
int a[maxDim];

	beOlvas(n, a);
	kiIr(n, a);
	int permSz = ciklikusPalindrom(n, a);	
	kiirEredmeny(permSz);
}


