/*
Egy sorozat egymás után elhelyezkedő elemekből álló részét, amely páros számokat tartalmaz páros 
tömbszakasznak nevezzük. Bármely ilyen tömbszakasznak legkevesebb két eleme van és, ha hozzáadunk 
egy másik tagot, a tömbszakasz elveszti a tulajdonságát. 

A tömbszakasz hossza egyenlő az elemeinek számával. 
A 2.txt bemeneti állományban legtöbb 10^6 természetes szám található (0 <= szám <= 10^9). 
Határozzuk meg az adott sorozat leghosszabb páros tömbszakaszainak darabszámát. 
Példa: legyen a sorozat 1 2 3 4 6 10 2 8 5 7 9 4 6 10 121 20 4 11 10 2 5 2 6 8 10 16. Az eredmény: 2
*/

#include <iostream>
#include <fstream>

using namespace std;

int const maxDim = 1000;

void beOlvas(int &n, int a[]){

    ifstream fin("paros2.txt");
    n = 0;
    int x;    
    while(fin >> x){
        n++;
        a[n] = x;
    }
}

void kiIr(int n, int a[]){

    cout << "n = " << n << endl;
    for(int i = 1; i <= n; i++)
        cout << a[i] << " ";
    cout << endl;
}

int feldolgoz(int n, int a[]){
// megkeresi a leghosszabb páros tömbszakaszt

    int hossz = 0;              // aktuális páros tömbszakasz hossza
    int maxhossz = 0;           // leghosszabb páros tömbszakasz hossza
    int db = 0;                 // azonos maximális hosszúságú páros tömbszakaszok darabszáma
    for(int i = 1; i <= n; i++){
        if(a[i] % 2 == 0) 
            hossz++;
        else{
            if(hossz >= 2){ // ha van egymás után legalább 2 páros elem
                if(hossz > maxhossz){ // ha az aktuális tömbszakasz hossza nagyobb, mint az eddigi legnagyobb 
                    maxhossz = hossz;
                    db = 1;
                }
                else{
                    if(hossz == maxhossz)// ha az aktuális tömbszakasz hossza egyenlő az eddigi legnagyobb hosszával 
                        db++;
                }
            }// két elem?
            hossz = 0;// az aktuális páros tömbszakasz feldolgozása véget ért, lehet kezdődik egy másik
        }// if páros
    }// for
    // az utolsó helyeken található esetleges tömbszakasz
    if(hossz >= 2){
        if(hossz > maxhossz){ 
            maxhossz = hossz;
            db = 1;
        }
        else{
            if(hossz == maxhossz)
                db++;
        }
    }
    return db;
}

void kiEredmeny(int db){
    cout << db << endl;
}

int main(){

    int n;
    int a[maxDim];
    beOlvas(n, a);
    kiIr(n, a);
    int db = feldolgoz(n, a);
    kiEredmeny(db);
    return 0;
}