/* 
Sors-számjegynek hívjuk azt a természetes számot, amelyet adott természetes számra a következőképpen számí­tunk ki: 
összeadjuk a szám számjegyeit, majd a kapott összeg számjegyeit, és így tovább, amíg a kapott összeg nem válik 
egyszámjegyű számmá. 
Például, a 182 sors-számjegye 2 (1 + 8 + 2 = 11, 1 + 1 = 2).
Egy pontosan k számjegyű p számot egy legkevesebb k számjegyű q szám előszeletének nevezünk, ha a q szám első k 
számjegyéből alkotott szám (balról jobbra tekintve) egyenlő p-vel. 
Például, 17 előszelete 174-nek, és 1713 előszelete 1 713 242-nek. 
Legyen az sz természetes szám (0 < sz ≤ 10 000) és az m sorral és n oszloppal (0 < m ≤ 100, 0 < n ≤ 100) rendelkező 
A mátrix (kétdimenziós tömb), amelynek elemei 30 000-nél kisebb természetes számok. 
Írjunk programot, amely meghatározza és kiírja az sz szám leghosszabb előszeletét, amelyet az adott mátrix elemeinek 
megfelelő sors-számjegyeiből fel lehet építeni. Egy ilyen sors-számjegyet akárhányszor fel lehet használni. 
Ha nem építhető fel előszelet, a program írja ki a „nem létezik előszelet” üzenetet.
*/

#include <iostream>
#include <fstream>

using namespace std;

ifstream f("eloszelet.in");

const int maxDim = 100;
const int maxSzjSz = 10;

void beOlvas(int &szam, int &m, int &n, int A[][maxDim]){
// bemenet

	f >> szam >> m >> n;
	for (int i = 0; i < m; i++){
		for (int j = 0; j < n; j++)
			f >> A[i][j];
	}
}

void kiIrAdatok(int szam, int m, int n, int A[][maxDim]){
// kiírjuk a bemenetet

	cout << "A bemenet: " << endl;
	cout << "Az adott szam = " << szam << endl;
	cout << "Az adott tomb:" << endl;
	for (int i = 0; i < m; i++){
		for (int j = 0; j < n; j++)
			cout << A[i][j] << " ";
		cout << endl;
	}
}

int sorsSzamjegy(int x){
// meghatározzuk x sorsszámjegyét

	while(x > 9){			// x-nek több, mint egy számjegye van
		int s = 0;			// x számjegyeinek összege
		while(x > 0){		
			s += x % 10;	// az összegbe tesszük az aktuális számjegyet
			x /= 10;		// osztjuk x-et, amíg 0-vá válik
		}
		x = s;				// x-et felülírjuk számjegyeinek összegével
	}
	return x;				// x-nek most egy számjegye van 
}

int prefixMaxSzamjeggyel(int szam, int m, int n, int A[][maxDim], int szamjegyek[], int &szamjegyekSzama){
// meghatározzuk a kért előszeletet

	bool elofordulasok[maxSzjSz];
	int i = 0;
	for (i = 0; i < maxSzjSz; i++)		// létrehozzuk az előfordulások tömbjét
		elofordulasok[i] = 0;
	for (i = 0; i < m; i++){
		for (int j = 0; j < n; j++)
			elofordulasok[sorsSzamjegy(A[i][j])] = 1;	// az előfordulások tömbjének aktualizálása
	}
	szamjegyekSzama = 0;				// a "szam" számjegyeinek darabszámát
	while (szam > 0){
		szamjegyek[szamjegyekSzama++] = szam % 10;	// a "szam" számjegyeinek sorozata
		szam /= 10;
	}
	i = szamjegyekSzama - 1;	// bejárjuk a számjegyek sorozatát
	while ((i >= 0) && (elofordulasok[szamjegyek[i]]))	// létezik sorsszámjegy, amely egyenlő az aktuális számjeggyel
		i--;				
	return szamjegyekSzama - i - 1;
}

void kiIrEloszelet(int hossz, int szamjegyek[], int szamjegyekSzama){
// kiírjuk az eredményt

	cout << endl << "Az eredmeny:" << endl;
	if (hossz == 0)
		cout << "nincs eloszelet";
	else{
		cout << "A leghosszabb eloszelet hossza " << hossz << endl;
		cout << "A leghosszabb eloszelet:" << endl;
		for(int i = 0; (i < hossz && i < szamjegyekSzama); i++)
			cout << szamjegyek[szamjegyekSzama - i - 1];
	}
	cout << endl;
}

int main(){
	
	int szam, m, n ;
	int A[maxDim][maxDim];
	beOlvas(szam, m, n, A);
	kiIrAdatok(szam, m, n, A);
	int szamjegyek[maxSzjSz];
	int szamjegyekSzama = 0;
	int hossz = prefixMaxSzamjeggyel(szam, m, n, A, szamjegyek, szamjegyekSzama);
	kiIrEloszelet(hossz, szamjegyek, szamjegyekSzama);
}
